GNUNET-DOWNLOAD(1)

NAME
gnunet-download - a command line interface for downloading files from GNUnet

SYNOPSIS
gnunet-download [-a LEVEL | --anonymity=LEVEL] [-c FILENAME | --config=FILENAME] [-D | --delete-incomplete] [-h | --help] [-L LOGLEVEL | --loglevel=LOGLEVEL] [-n | --no-network] [-o FILENAME | --output=FILENAME] [-p DOWNLOADS | --parallelism=DOWNLOADS] [-r REQUESTS | --request-parallelism=REQUESTS] [-R | --recursive] [-v | --version] [-V | --verbose] <GNUNET_URI>

DESCRIPTION
Download files from GNUnet. The options are as follows:

-a LEVEL | --anonymity=LEVEL
    This option can be used to specify additional anonymity constraints. The default is 1. If set to 0, GNUnet will publish the file non-anonymously and in fact sign the advertisement for the file using your peer's private key. This will allow other users to download the file as fast as possible, including using non-anonymous methods (discovery via DHT and CADET transfer). If you set it to 1 (default), you use the standard anonymous routing algorithm (which does not explicitly leak your identity). However, a powerful adversary may still be able to perform traffic analysis (statistics) to over time discovery your identity. You can gain better privacy by specifying a higher level of anonymity (using values above 1). This tells FS that it must hide your own requests in equivalent-looking cover traffic. This should confound an adversaries traffic analysis, increasing the time and effort it would take to discover your identity. However, it also can significantly reduce performance, as your requests will be delayed until sufficient cover traffic is available. The specific numeric value (for anonymity levels above 1) is simple: Given an anonymity level L (above 1), each request FS makes on your behalf must be hidden in L-1 equivalent requests of cover traffic (traffic your peer routes for others) in the same time-period. The time-period is twice the average delay by which GNUnet artificially delays traffic. Note that regardless of the anonymity level you choose, peers that cache content in the network always use anonymity level 1.

-c FILENAME | --config=FILENAME
    Use config file (default: ~/.config/gnunet.conf)

-D | --delete-incomplete
    Causes gnunet-download to delete incomplete downloads when aborted with CTRL-C. Note that complete files that are part of an incomplete recursive download will not be deleted even with this option. Without this option, terminating gnunet-download with a signal will cause incomplete downloads to stay on disk. If gnunet-download runs to (normal) completion finishing the download, this option has no effect.

-h | --help
    Print the help page.

-L LOGLEVEL | --loglevel=LOGLEVEL
    Change the loglevel. Possible values for LOGLEVEL are ERROR, WARNING, INFO and DEBUG.

-n | --no-network
    Only search locally, do not forward requests to other peers.

-o FILENAME | --output=FILENAME
    Write the file to FILENAME. Hint: when recursively downloading a directory, append a '/' to the end of the FILENAME to create a directory of that name. If no FILENAME is specified, gnunet-download constructs a temporary ID from the URI of the file. The final filename is constructed based on meta-data extracted using libextractor(1) (if available).

-p DOWNLOADS | --parallelism=DOWNLOADS
    Set the maximum number of allowed parallel downloads to DOWNLOADS. More parallel downloads can, to some extent, improve the overall time to download content. However, parallel downloads also take more memory (see also -r which can be used to limit memory utilization) and more sockets. This option is used to limit the number of files that are downloaded in parallel. -r can be used to limit the number of blocks that are concurrently requested. As a result, the value only matters for recursive downloads. The default value is 32.

-r REQUESTS | --request-parallelism=REQUESTS
    Set the maximum number of parallel requests that is allowed. If multiple files are downloaded, gnunet-download will not run them in parallel if this would cause the number of pending requests to possibly exceed the given value. This is useful since, for example, downloading dozens of multi-gigabyte files in parallel could exhaust memory resources and would hardly improve performance. Note that the limit only applies to this specific process and that other download activities by other processes are not included in this limit. Consider raising this limit for large recursive downloads with many large files if memory and network bandwidth are not fully utilized and if the parallelism limit (-p) is not reached. This option also only matters for recursive downloads. The default value is 4092.

-R | --recursive
    Download directories recursively (and in parallel). Note that the URI must belong to a GNUnet directory and that the filename given to -o must end in '.gnd' — otherwise, you will receive an error. You may want to use "DIRNAME/.gnd" for the filename, this way a directory "DIRNAME/" will be created, and GNUnet's internal directory information will be stored in "DIRNAME/.gnd". However, it is also possible to specify "DIRNAME.gnd", in which case the files from the directory will end up in "DIRNAME/", while GNUnet's directory meta data will be in "DIRNAME.gnd".

-v | --version
    Print the version number.

-V | --verbose
    Print progress information.

  NOTES
The GNUNET_URI is typically obtained from gnunet-search(1). gnunet-fs-gtk(1) can also be used instead of gnunet-download. If you ever have to abort a download, you can at any time continue it by re-issuing gnunet-download with the same filename. In that case GNUnet will not download blocks again that are already present. GNUnet's file-encoding will ensure file integrity, even if the existing file was not downloaded from GNUnet in the first place. Temporary information will be appended to the target file until the download is completed.

FILES
~/.config/gnunet.conf GNUnet configuration file

SEE ALSO
gnunet-fs-gtk(1), gnunet-publish(1), gnunet-search(1), gnunet-service-fs(1), gnunet.conf(5)

The full documentation for gnunet is maintained as a Texinfo manual. If the info(1) and gnunet programs are properly installed at your site, the command

    info gnunet

should give you access to the complete handbook,

    info gnunet-c-tutorial

will give you access to a tutorial for developers.

Depending on your installation, this information is also available in gnunet(7) and gnunet-c-tutorial(7).

BUGS
Report bugs by using https://bugs.gnunet.org or by sending electronic mail to <gnunet-developers@gnu.org>.